/*
 * ȨϢ: Copyright (c) ſƼ޹˾
 * ļ: test_auth.c
 * ļ: ֤ؽӿڲԳ
 * ʱ    : 2011-12-05
 * ժ    Ҫ:
 *     : ţʤ
 *     : 1.0
 */

#include "ftauthng.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

#define  TEST_PIN "1234"

#define TOTP_PDATA_STR  "gQAKMDAwMDAwMDAwMxRWVYqACeqvQ3oeHhTcpl/GLyQLFCpuAAACBg" \
						"AAAAAAADwAAAAAAAAAAAAAO5rKAHc1lAAACv////8AAAAAAAAAAAAA" \
						"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" \
						"AAAAAAABtPQ1JBLTE6SE9UUC1TSEExLTg6UU4wOC1UMU0bT0NSQS0x" \
						"OkhPVFAtU0hBMS04OlFONjQtVDFNF09DUkEtMTpIT1RQLVNIQTEtODp"\
						"RTjA4AAAAAAAAAAAAAAAAAHCl"

#define TOTP_SN "0000000003"

/* ˽ݽṹ */
StTokenData pdata;

/* Ƽ */
int test_enable_token()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* 趨û, һΪк */
    if ( FT_API_SUCC != ( ret = set_user_login( &pdata,
                                                TOTP_SN ) ) )
    {
        printf( "set_user_login err: %d\n", ret );
        return ret;
    }
    printf( "set_user_login ok\n" );

    /* PIN */
    if ( FT_API_SUCC != (ret = set_pin( &pdata,
                                        TEST_PIN ) ) )
    {
        printf( "set_pin err: %d\n", ret );
        return ret;
    }
    printf( "set_pin ok\n" );

    /*  */
    if ( FT_API_SUCC != (ret = enable_token( &pdata ) ) )
    {
        printf( "enable_token err: %d\n", ret );
        return ret;
    }
    printf( "enable_token ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤սӦ */
int
test_chk_chp()
{
    int ret = FT_API_SUCC;
	char chlg[65] = {'\0'};
	char rz[11] = {'\0'};

    /* ȽַתΪṹ */
    decode_pdata(&pdata);

	if ( FT_API_SUCC !=
         ( ret = check_chpass((long)1000000000, // Ӧ̬ʵʱ
                               &pdata,
                               "37354187",		//  gen_chpass ӿڲӦ̬
                               TEST_PIN,
                               "32000154")))	//  gen_chlg ӿڲսֵ
    {
        printf( "check_chpass err: %d\n", ret );
    }
    else
    {
        printf( "check_chpass ok\n" );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤ǩ */
int
test_chk_sig()
{
    int ret = FT_API_SUCC;
	char otp[11] = {'\0'};

    /* ȽַתΪṹ */
    decode_pdata(&pdata);
	
	gen_sigpass((long)1000000060,&pdata,otp,"11120615060000000003100");

    if ( FT_API_SUCC !=
         ( ret = check_sigpass( (long)1000000060, // ǰǩʵʱ
                                &pdata,
                                otp,//"76904056", //  gen_sigpass ӿڲĽǩ,"46873688"
                                TEST_PIN,
                                "11120615060000000003100" ) ) ) // ʵʵǩ
    {
        printf( "check_sigpass err: %d\n", ret );
    }
    else
    {
        printf( "check_sigpass ok\n" );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤̬ */
int
test_chk_pswd()
{
    int ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata(&pdata);

    if ( FT_API_SUCC !=
         ( ret = check_password( (long)1000000000, //  OTP ʵʱ
                                 &pdata,
                                 "430072",         //  genotp ӿڲ OTP
                                 TEST_PIN ) ) )
    {
        printf( "check_password err: %d\n", ret );
    }
    else
    {
        printf( "check_password ok\n" );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤֤ */
int
test_chk_hacode()
{
    int  ret = FT_API_SUCC;
    char otp[RESP_SIZE];

    /* ȽַתΪṹ */
    decode_pdata(&pdata);

    if ( FT_API_SUCC !=
         ( ret = gen_hacode( &pdata,
                             "123456", // սֵ(豸)
                             otp ) ) )
    {
        printf( "gen_hacode err: %d\n", ret );
    }
    else
    {
        printf( "gen_hacode ok, otp: %s\n", otp );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
test_reuse_chk_pswd()
{
	int  ret = FT_API_SUCC;
	char otp[OTP_SIZE];

	/* ȽַתΪṹ */
	decode_pdata(&pdata);
	
	set_otp_reused(&pdata, 1);	//ʱ䵥λ30
	
	if ( FT_API_SUCC !=
         ( ret = check_password((long)1000000100,
                                 &pdata,
                                 "111174",
                                 TEST_PIN)))
    {
        printf( "check_password err: %d\n",ret);
    }
    else
    {
        printf( "check_password first ok\n" );

		if ( FT_API_SUCC !=
			( ret = check_password((long)1000000129,
									&pdata,
									"111174",
									TEST_PIN)))
			printf( "check_password reuse err: %d\n",ret);
		else
			printf( "check_password reuse ok\n");
    }

	/* ƽṹ± */
	encode_pdata(&pdata);
	return ret;
}

int
test_reuse_chk_chp()
{
	int ret = FT_API_SUCC;

	char chlg[65] = {'\0'};
	char rz[11] = {'\0'};

	/* ȽַתΪṹ */
	decode_pdata(&pdata);

	set_chpass_reused(&pdata, 1);	//ʱ䵥λ30

	if ( FT_API_SUCC !=
         ( ret = check_chpass( (long)1000000200,	//  OTP ʵʱ
                               &pdata,
                               "36451958",			//ֵΪսֵɵotp֤
                               TEST_PIN,
                               "47430438")))		//ֵΪgen_chlg(&pdata,chlg)
    {
        printf( "check_chpass err: %d\n", ret );
    }
    else
    {
        printf( "check_chpass first ok\n" );

		if ( FT_API_SUCC !=
         ( ret = check_chpass( (long)1000000229,	
                               &pdata,
                               "36451958",
                               TEST_PIN,
                               "47430438")))
		{
			printf( "check_chpass reuse err: %d\n", ret );
		}
		else
		{
			printf( "check_chpass reuse ok\n" );
		}
    }

	/* ƽṹ± */
	encode_pdata(&pdata);
	return ret;
}

int
main( int   argc,
      char *argv[] )
{
    /* ò˽, ʵʶӦΪݱTK_PRIVATE_DATA */
    strcpy( pdata.priv_data, TOTP_PDATA_STR );

    test_enable_token();
    test_chk_pswd();
    test_chk_chp();
    test_chk_sig();
    test_chk_hacode();
    test_reuse_chk_pswd();
    test_reuse_chk_chp();

    return 0;
}
