/*
 * ȨϢ: Copyright (c) ſƼ޹˾
 * ļ: test_chap.c
 * ļ: ֤ؽӿڲԳ
 * ʱ    : 2011-12-05
 * ժ    Ҫ:
 *     : ţʤ
 *     : 1.0
 */

#include "ftauthng.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

#define TEST_PIN "123456"
/*˽δãҪ*/
#define TOTP_PDATA_STR "gQAKMDAwMDAwMDAwMhRWVYqACeqvQ3oeHhTcpl/GLyQLFTpPAAABBgAAAAAAADwAAAA" \
						"AAAAAAAAAO5rKAHc1lAAACv////8AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" \
						"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABXtQ=="

#define	TOTP_SN "0000000002"

/* ˽ݽṹ */
StTokenData pdata;

/*	Ƽ	*/
int test_enable_token()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* 趨û, һΪк */
    if ( FT_API_SUCC != ( ret = set_user_login( &pdata,
                                                TOTP_SN ) ) )
    {
        printf( "set_user_login err: %d\n", ret );
        return ret;
    }
    printf( "set_user_login ok\n" );

    /* PIN */
    if ( FT_API_SUCC != (ret = set_pin( &pdata,
                                        TEST_PIN ) ) )
    {
        printf( "set_pin err: %d\n", ret );
        return ret;
    }
    printf( "set_pin ok\n" );

    /*  */
    if ( FT_API_SUCC != (ret = enable_token( &pdata ) ) )
    {
        printf( "enable_token err: %d\n", ret );
        return ret;
    }
    printf( "enable_token ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤CHAP */
int
test_check_chap_pass()
{
    int           ret = FT_API_SUCC;
    unsigned char chlg[16];
    unsigned char pswd[17];

    /* CHAPսֵ, ʵCHAPͻ(:VPN豸) */
    chlg[0] = 0x00;
    chlg[1] = 0x01;
    chlg[2] = 0x02;
    chlg[3] = 0x03;
    chlg[4] = 0x04;
    chlg[5] = 0x05;
    chlg[6] = 0x06;
    chlg[7] = 0x07;
    chlg[8] = 0x08;
    chlg[9] = 0x09;
    chlg[10] = 0x0a;
    chlg[11] = 0x0b;
    chlg[12] = 0x0c;
    chlg[13] = 0x0d;
    chlg[14] = 0x0e;
    chlg[15] = 0x0f;

    pswd[0] = 0x00;
    pswd[1] = 0x9a;
    pswd[2] = 0xd7;
    pswd[3] = 0x8f;
    pswd[4] = 0x42;
    pswd[5] = 0xf5;
    pswd[6] = 0x0b;
    pswd[7] = 0x1b;
    pswd[8] = 0x1d;
    pswd[9] = 0xa4;
    pswd[10] = 0xde;
    pswd[11] = 0xe2;
    pswd[12] = 0xa6;
    pswd[13] = 0x74;
    pswd[14] = 0xc3;
    pswd[15] = 0x7d;
    pswd[16] = 0xfb;
    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    if ( FT_API_SUCC !=
         (ret = check_chap_pass( (long)1322794528, // Ӧ̬ʵʱ
                                 &pdata,
                                 chlg,
                                 16,
                                 pswd,
                                 17 ) ) )
    {
        printf( "check_chap_pass err: %d\n", ret );
    }
    else
    {
        printf( "check_chap_pass ok\n" );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֤CHAP */
int
test_check_mschap_pass()
{
    int           ret = FT_API_SUCC;
    unsigned char chlg2[8];
    unsigned char pswd2[50];
    unsigned char pswd_hash[16];
    unsigned char hash_hash[16];

    /* MSCHAPսֵ, ʵMSCHAPͻ(: MS NAS) */
    chlg2[0] = 0x00;
    chlg2[1] = 0x01;
    chlg2[2] = 0x02;
    chlg2[3] = 0x03;
    chlg2[4] = 0x04;
    chlg2[5] = 0x05;
    chlg2[6] = 0x06;
    chlg2[7] = 0x07;

    pswd2[0] = 0x00;
    pswd2[1] = 0x01;
    pswd2[2] = 0x00;
    pswd2[3] = 0x00;
    pswd2[4] = 0x00;
    pswd2[5] = 0x00;
    pswd2[6] = 0x5c;
    pswd2[7] = 0xf7;
    pswd2[8] = 0xff;
    pswd2[9] = 0xbf;
    pswd2[10] = 0x15;
    pswd2[11] = 0xf9;
    pswd2[12] = 0x50;
    pswd2[13] = 0x00;
    pswd2[14] = 0x24;
    pswd2[15] = 0x93;
    pswd2[16] = 0x63;
    pswd2[17] = 0x00;
    pswd2[18] = 0xf4;
    pswd2[19] = 0x8f;
    pswd2[20] = 0x63;
    pswd2[21] = 0x00;
    pswd2[22] = 0x10;
    pswd2[23] = 0xc5;
    pswd2[24] = 0x05;
    pswd2[25] = 0x08;
    pswd2[26] = 0x8a;
    pswd2[27] = 0x80;
    pswd2[28] = 0x21;
    pswd2[29] = 0xf1;
    pswd2[30] = 0xe9;
    pswd2[31] = 0x13;
    pswd2[32] = 0x16;
    pswd2[33] = 0x17;
    pswd2[34] = 0x7e;
    pswd2[35] = 0xec;
    pswd2[36] = 0x60;
    pswd2[37] = 0xb8;
    pswd2[38] = 0x64;
    pswd2[39] = 0xd6;
    pswd2[40] = 0xa8;
    pswd2[41] = 0xbd;
    pswd2[42] = 0x2b;
    pswd2[43] = 0x8e;
    pswd2[44] = 0x10;
    pswd2[45] = 0x15;
    pswd2[46] = 0xd1;
    pswd2[47] = 0x30;
    pswd2[48] = 0xcc;
    pswd2[49] = 0xcf;
    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    if ( FT_API_SUCC !=
         ( ret = check_mschap_pass( (long)1322794588, // Ӧ̬ʵʱ
                                    &pdata,
                                    2,
                                    chlg2,
                                    8,
                                    pswd2,
                                    50,
                                    pswd_hash,
                                    hash_hash ) ) )
    {
        printf( "check_mschap_pass err: %d\n", ret );
    }
    else
    {
        printf( "check_mschap_pass ok\n" );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
main( int   argc,
      char *argv[] )
{
    /* ò˽, ʵʶӦΪݱTK_PRIVATE_DATA */
    strcpy( pdata.priv_data, TOTP_PDATA_STR );

    test_enable_token();
    test_check_chap_pass();
    test_check_mschap_pass();

    return 0;
}
